// Copyright (c) 1994 James Clark
// See the file COPYING for copying permission.

#ifdef __GNUG__
#pragma implementation
#endif
#include "config.h"
#include "Dtd.H"
#include "setAll.H"
#include "Syntax.H"

EntitySet::EntitySet(const CString &name)
: name_(new StringResource<Char>(name))
{
}

Dtd::Dtd(const CString &name, Boolean isBase)
: EntitySet(name),
  nCurrentAttribute_(0),
  nElementDefinition_(0),
  nAttributeDefinitionList_(0),
  isBase_(isBase)
{
  documentElementType_ = new ElementType(name, nElementTypeIndex());
  insertElementType(documentElementType_);
}

Entity::DeclInType Dtd::declInType() const
{
  return isBase_ ? Entity::inBaseDtd : Entity::inOtherDtd;
}

Boolean Dtd::shortrefIndex(const CString &str, const Syntax &syntax,
			   int &index)
{
  const int *indexP = shortrefTable_.lookup(str);
  if (indexP) {
    index = *indexP;
    return 1;
  }
  if (!syntax.isValidShortref(str))
    return 0;
  shortrefTable_.insert(str, shortrefs_.length());
  index = int(shortrefs_.length());
  shortrefs_.grow() = str;
  return 1;
}

void Dtd::addNeededShortref(const CString &str)
{
  if (!shortrefTable_.lookup(str)) {
    shortrefTable_.insert(str, shortrefs_.length());
    shortrefs_.grow() = str;
  }
}
