// Copyright (c) 1994 James Clark
// See the file COPYING for copying permission.

#ifdef __GNUG__
#pragma implementation
#endif
#include "config.h"
#include "Notation.H"
#include "ParserState.H"
#include "Sd.H"
#include "Syntax.H"

Notation::Notation(const CString &name,
		   const ConstResourcePointer<StringResource<Char> > &dtdName,
		   Boolean dtdIsBase)
: NamedResource(name), defined_(0), dtdName_(dtdName), dtdIsBase_(dtdIsBase)
{
}

void Notation::setExternalId(ExternalId &id, const Location &defLocation)
{
  id.moveTo(externalId_);
  defined_ = 1;
  defLocation_ = defLocation;
}

void Notation::generateSystemId(ParserState &parser)
{
  CString str;
  if (parser.externalEntityOpener()
      ->generateSystemId(*this,
			 parser.sd().docCharset(),
			 (parser.syntax().namecaseGeneral()
			  ? parser.syntax().generalSubstTable()
			  : 0),
			 parser.messenger(),
			 str))
    externalId_.setEffectiveSystem(str);
}
