// Copyright (c) 1994 James Clark
// See the file COPYING for copying permission.

#ifndef Notation_INCLUDED
#define Notation_INCLUDED 1
#ifdef __GNUG__
#pragma interface
#endif

#include "Owner.H"
#include "CString.H"
#include "NamedResource.H"
#include "types.H"
#include "ResourcePointer.H"
#include "ExternalId.H"
#include "Boolean.H"
#include "Attributed.H"
#include "StringResource.H"

class ParserState;

class Notation : public NamedResource, public Attributed {
public:
  Notation(const CString &,
	   const ConstResourcePointer<StringResource<Char> > &dtdName,
	   Boolean dtdIsBase);
  void setExternalId(ExternalId &, const Location &);
  const ExternalId &externalId() const;
  Boolean defined() const;
  const Location &defLocation() const;
  void generateSystemId(ParserState &);
  const CString &dtdName() const;
  Boolean dtdIsBase() const;
private:
  Notation(const Notation &);	// undefined
  void operator=(const Notation &); // undefined
  PackedBoolean defined_;
  ExternalId externalId_;
  Location defLocation_;
  ConstResourcePointer<StringResource<Char> > dtdName_;
  Boolean dtdIsBase_;
};

inline
const ExternalId &Notation::externalId() const
{
  return externalId_;
}

inline
Boolean Notation::defined() const
{
  return defined_;
}

inline
const Location &Notation::defLocation() const
{
  return defLocation_;
}

inline
const CString &Notation::dtdName() const
{
  return *dtdName_;
}

inline
Boolean Notation::dtdIsBase() const
{
  return dtdIsBase_;
}

#endif /* not Notation_INCLUDED */
