// Copyright (c) 1994 James Clark
// See the file COPYING for copying permission.

#ifdef __GNUG__
#pragma implementation
#endif
#include "config.h"
#include "ParserOptions.H"

ParserOptions::ParserOptions()
: datatag(0),
  omittag(1),
  rank(1),
  shorttag(1),
  linkSimple(1000),
  linkImplicit(1),
  linkExplicit(1),
  concur(0),
  subdoc(99999999),
  formal(1),
  shortref(1),
  inhibitIdrefCheck(0),
  warnSgmlDecl(0),
  warnShould(0),
  warnDuplicateEntity(0),
  warnUndefinedElement(0),
  warnDefaultEntityReference(0),
  warnMixedContent(0)
{
  for (int i = 0; i < nQuantity; i++)
    quantity[i] = 99999999;
  quantity[BSEQLEN] = 960;
  quantity[NORMSEP] = 2;
  quantity[LITLEN] = 24000;
  quantity[PILEN] = 24000;
  quantity[DTEMPLEN] = 24000;
}

void ParserOptions::enableAllWarnings()
{
  warnSgmlDecl = 1;
  warnDuplicateEntity = 1;
  warnShould = 1;
  warnUndefinedElement = 1;
  warnDefaultEntityReference = 1;
  warnMixedContent = 1;
}

ParserSubdocOptions::ParserSubdocOptions()
: inheritActiveLinkTypes(0),
  inheritIncludes(0),
  referenced(0)
{
}
